package org.hisrc.hifaces20.demo.messageboard;

import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceException;

import org.springframework.orm.jpa.JpaCallback;
import org.springframework.orm.jpa.support.JpaDaoSupport;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

@Transactional
public class JpaMessageDao extends JpaDaoSupport implements MessageDao {

	@Override
	@Transactional(propagation = Propagation.SUPPORTS, readOnly = true)
	public List<String> getMessages() {

		@SuppressWarnings("unchecked")
		final List<String> messages = getJpaTemplate().executeFind(
				new JpaCallback<List<String>>() {

					@Override
					public List<String> doInJpa(EntityManager em)
							throws PersistenceException {

						return em
								.createQuery(
										"SELECT m.content FROM Message m ORDER BY m.id DESC")
								.getResultList();
					}
				});
		return messages;
	}

	@Override
	@Transactional(propagation = Propagation.REQUIRED, readOnly = false)
	public void saveMessage(String content) {
		final Message message = new Message();
		message.setContent(content);
		getJpaTemplate().persist(message);
	}

}
